/*
 * SWFxME is an open source solution to extend Flash Lite
 * using J2ME (http server). It is developed to enrich Flash 
 * Lite with certain features which it lacks like writing to 
 * a file, listing a directory etc.Simply , 
 *          Flash Lite + J2ME  = More Fun :)
 * It is quite easy to extend SWFxME , please read documentation for more details.
 * Drop me a mail , if u have further questions or any feedback :
 * @ email : sajisoft@gmail.com
 * @ Author of SWFxME : Sajid Ali Anjum (a.k.a SajiSoft)
 * Credit also goes to : 
 * Felipe Andrade (for his Jarpa project)
 */

/*This is the Functions.java class in which u can add more
 * functions of your choice. Dont know J2ME code that much???
 * Just visit http://wiki.forum.nokia.com for ready made code
 * snippets .
 */

package SWFxME;

import java.io.DataOutputStream;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.Vector;
import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;

public class Functions {
    public static Functions _instance;
    
 public static Functions getInstance() {
        if(_instance == null) {
            _instance = new Functions();
        }
        
        return _instance;
    
 }
 
 //function to convert hexa string to normal string
 public String converter(String data)
 {
     
     char s;
     int a = 0;
     String ret = "";
     for (int i = 0 ; i <= data.length() - 1 ; i++ )
     {
         s = data.charAt(i);
         if (s == '%')
         {  
             char ch = data.charAt(i+2);
             switch(ch)  
            {  
                case 'C': ret += "<" ;  i = i+2; break;  
                case 'E': ret += "." ;  i = i+2; break;  
                case 'F': ret += "/" ;  i = i+2; break;    
                case 'A': ret += ":" ;  i = i+2; break;  
                case 'D': ret += "-" ;  i = i+2; break;  
                default: ret += " " ;  i = i+2; break;  
            } 
         }
         else 
         {
             ret += s;
         }
     }
     
     return ret;
 }

 //function to split a string into arrays by a provided delimiter
   public static String[] split(String splitStr, String delimiter) {  
    StringBuffer token = new StringBuffer();  
    Vector tokens = new Vector();  
    // split  
    char[] chars = splitStr.toCharArray();  
    for (int i=0; i < chars.length; i++) {  
        if (delimiter.indexOf(chars[i]) != -1) {  
            // we bumbed into a delimiter  
            if (token.length() > 0) {  
                tokens.addElement(token.toString());  
                token.setLength(0);  
            }  
        } else {  
            token.append(chars[i]);  
        }  
    }  
    // don't forget the "tail"...  
    if (token.length() > 0) {  
        tokens.addElement(token.toString());  
    }  
    // convert the vector into an array  
    
    String[] splitArray = new String[tokens.size()];  
    for (int i=0; i < splitArray.length; i++) {  
        splitArray[i] = (String) tokens.elementAt(i);
    }  
    return splitArray;  
}  

 // a function to trim a string from ends according to rule
   public String trim_request(String a)
{
    int ln = a.length();
    String strn = "";
    char c;
    for (int i = 5 ; i <= ln-11 ; i++)
    {
    c = a.charAt(i);
    strn += c;
 
}
   return strn;
    }
          
   
   
//from  here you can add your own functions .  
 
 public String write_file(String path , String content, String attribute)
 {
     String error = "";
     attribute = attribute.toLowerCase();
       byte data_to_write[] = content.getBytes();
           try
        {   
               
       FileConnection fconn = (FileConnection)Connector.open(path,Connector.READ_WRITE);
      
       if (!fconn.exists()) {
               fconn.create();
            }
 else
        {
       if (!attribute.equals("append"))
       {
           fconn.delete(); 
           fconn.create();
       }
        
}
       if (attribute.equals("append"))
       {
OutputStream os = fconn.openOutputStream(fconn.fileSize());
DataOutputStream dos = new DataOutputStream(os);
dos.writeUTF(content);
            dos.close();
            fconn.close();
       }
       else
       {
        OutputStream ops = fconn.openOutputStream();
            ops.write(data_to_write);
            ops.close();
            fconn.close();
       }    
       }
       catch (Exception e)
       {
           error = e.toString();
       }
       if (error.equals(""))
       {
           error = "&feedback=Written_Successfull&";
       }
       else
       {
            error = "&feedback=" + error + "&";
       }
    return error;
 }
 
 
 public String list_dir(String path)
 {
            String files = "";
            String result = "&feedback=";
                
     try
     {
       FileConnection fc = (FileConnection)Connector.open(path, Connector.READ);
            Enumeration filelist = fc.list("*", false); //dont show hidden files
            String filename;
            while(filelist.hasMoreElements()) {
                filename = (String) filelist.nextElement();
              
                    files += filename+"__SEP__";
                
            }    
            fc.close();
    result += files;
     }
     catch (Exception e)
     {
        result = "&error=" + e.toString() + "&";
     }
            /*it returns a string containing contents of the provided dir
             seperated by a seperator __SEP__ */
     return result;
 }
 
 public String chk_server()
 {
     return "&feedback=SWFxME Server Is Working Quite Fine. :)&";
 }
 
 public String close_server()
 {
     String feedback = "Server Closed Succesfully";
     String error = "";
     error = FLServer.getInstance().close_server();
     if (!error.equals(""))
     {
         feedback = error;
     }
     return feedback;
 }
 
 // add more functions here
 
 
 
 public String main_handler(String args )
 {
     String[] str = new String[20];
    String[] str1 = new String[20];
     String[] temp = new String[2];
     String to_send = "";
     String func_name = "";
     String data = "a=1";
     String error = "";
     //Trim The Client Request From Ends
     args = trim_request(args);
     //Extract Function Name & Arguments
     // From The Client Request
     temp = split(args, "?");
    func_name = temp[0];
    if (temp.length != 1)
    {
    data = temp[1];
    }
    /*Assign Values From Request 
     to J2me variables
     declare more String variables here*/
    String content = "";
    String path = "";
    String attribute = "";
    //Assign values 
    str = split(data, "&");
    for (int i = 0 ; i <= str.length -1  ; i++)
    {
        str1 = split(str[i], "=");
       try 
       {
      if (str1[0].equals("content"))
      {
          content = str1[1];
      }
      else if (str1[0].equals("path"))
        {
           path = str1[1];
        }
       else if (str1[0].equals("attribute"))
        {
           attribute = str1[1];
        }
      //add more argument names here
      
       }
       catch (Exception e)
       {
           error = "Error Retrieving Attributes : " + e.toString();
       }
      }
    /*if retrieved argument contain hexa string for example 
 mostly when we pass path i.e "c:\\sa.txt" or argument with specail characters
 then they are converted to respective hexa number by flash client.Therefore, in the below code
 we just convert the converted hexa  strings to their respective normal strings */
    if (!path.equals(""))
    {
      path = converter(path);
    }
     if (!content.equals(""))
    {
      content = converter(content);
    } 
    if (!attribute.equals(""))
    {
      attribute = converter(attribute);
    }
    //function conditions starts from here
  if (func_name.equals("write_file"))
  {
     to_send = write_file(path, content, attribute);
   }
  else if (func_name.equals("list_dir"))
  {
     to_send = list_dir(path);
   }
  else if (func_name.equals("crossdomain.xml"))
  {
     to_send = "<?xml version=\"1.0\"?><cross-domain-policy><allow-access-from domain=\"*\" to-ports=\"*\" /></cross-domain-policy>" ;
   }
  else if (func_name.equals("chk_server"))
  {
   to_send = chk_server();
  } 
  else if (func_name.equals("close_server"))
  {
   to_send = close_server();
  }
    //add more functions conditions here
  
 return to_send ;
 }
}