/*
 * SWFxME is an open source solution to extend Flash Lite
 * using J2ME (http server). It is developed to enrich Flash 
 * Lite with certain features which it dont have like writing to 
 * a file, listing a directory etc.Simply , 
 *          Flash Lite + J2ME  = More Fun :)
 * It is quite easy to extend SWFxME , please read documentation for more details.
 * Drop me a mail , if u have further questions or any feedback :
 * @ email : sajisoft@gmail.com
 * @ Author of SWFxME : Sajid Ali Anjum (a.k.a SajiSoft)
 * Credit also goes to : 
 * Felipe Andrade (for his Jarpa project)
 */

package SWFxME;


import java.io.DataOutputStream;
import java.io.InputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;

public class Resources {
 public static Resources _instance;
        
    // data from the swf
    private InputStream _incomingData;
    
    private String _contentFolder = "";
    private String _toFolder = "";
    private String _fromFolder = "";

    private String _error = "";
    public int error = 0;
    
    public static Resources getInstance() {
        if(_instance == null)
            _instance = new Resources();
        
        return _instance;
    }
    
    public String copyResources(String aFolder) {
        _toFolder = aFolder;
        // extract folder name from the given path
        int index = aFolder.lastIndexOf('/');
        String fileName = aFolder.substring(index + 1, aFolder.length());
        _contentFolder = aFolder.substring(0, index);        
    
        
         _fromFolder =  "/" + fileName;
         
        try {
            // get resource swf file from the jar
            this._incomingData = this.getClass().getResourceAsStream(this._fromFolder);
            // open a connection (sign problems ... on N95 only working in the memory card)
            FileConnection fConn = (FileConnection)Connector.open(this._toFolder);                        
           
if (_incomingData != null)
{
               _error = "Status : Resource Swf File Found !";
}
else
{
             _error  = "Error : Resource Swf File Doesnt Exist !" ;   
 error = 1;
}
            //if swf file doesnt exists, create it
            if (!fConn.exists() && _incomingData != null){
             FileConnection fContent = (FileConnection)Connector.open(this._contentFolder);
            
             if(!fContent.exists()){
                fContent.mkdir();
            }
            fContent.close();
                fConn.create();

                int ch = 0;
                DataOutputStream dataStorage = fConn.openDataOutputStream();

                // write to the file
                while ((ch = this._incomingData.read()) > -1) {
                    dataStorage.write(ch);
               }
               // closes
               dataStorage.flush();
               dataStorage.close();

               if(this._incomingData != null)
                   this._incomingData.close();
            
            _error = "Status : File Copied Successfully !";
            }
            else if (fConn.exists())
            {
             _error = "Status : Swf File Already Exists !";   
            }           
            
            fConn.close();
        } catch (Exception e) {
         _error = "Error Resource (2) :" +  e.toString();  
         error = 1;
        }
        return _error;
    }
}
